package org.seasar.velocity.tools;

import org.apache.velocity.tools.view.tools.ViewTool;
import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.SingletonS2ContainerFactory;

/**
 * DICONファイルにコンポーネント登録しなくても、toolbox.xmlから
 * 自動的に登録を行なうToolInfoクラス。
 */
public class AutoRegisteringS2ServletToolInfo extends S2ServletToolInfo {

  private static final String COMPONENT_NAME_PREFIX = "velocity.toolbox.";

  /**
   * 親メソッドと違い、コンポーネント名を元にコンポーネントを取得する。
   * こうすることで、コンポーネント衝突を回避できる。
   */
  public Object getInstance(Object initData) {
    Object tool = null;

    S2Container container = SingletonS2ContainerFactory.getContainer();
    String compName = COMPONENT_NAME_PREFIX + getKey();
    if (!container.hasComponentDef(compName))
        container.register(clazz, compName);
    tool = container.getComponent(compName);

    if (initializable) {
      ((ViewTool) tool).init(initData);
    }

    return tool;
  }
}